/* Job.c generated by valac 0.55.3, the Vala compiler
 * generated from Job.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <glib.h>
#include "cups/cups.h"
#include <glib-object.h>
#include "cups/ipp.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

enum  {
	PRINTERS_JOB_0_PROPERTY,
	PRINTERS_JOB_NUM_PROPERTIES
};
static GParamSpec* printers_job_properties[PRINTERS_JOB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _ippDelete0(var) ((var == NULL) ? NULL : (var = (ippDelete (var), NULL)))
enum  {
	PRINTERS_JOB_STOPPED_SIGNAL,
	PRINTERS_JOB_COMPLETED_SIGNAL,
	PRINTERS_JOB_STATE_CHANGED_SIGNAL,
	PRINTERS_JOB_NUM_SIGNALS
};
static guint printers_job_signals[PRINTERS_JOB_NUM_SIGNALS] = {0};

struct _PrintersJobPrivate {
	PrintersPrinter* printer;
	gint uid;
};

static gint PrintersJob_private_offset;
static gpointer printers_job_parent_class = NULL;

static void ___lambda5_ (PrintersJob* self,
                  const gchar* text,
                  const gchar* printer_uri,
                  const gchar* name,
                  guint32 state,
                  const gchar* state_reasons,
                  gboolean is_accepting_jobs,
                  guint32 job_id,
                  guint32 job_state,
                  const gchar* job_state_reason,
                  const gchar* job_name,
                  guint32 job_impressions_completed);
static void ____lambda5__cups_notifier_job_completed (CupsNotifier* _sender,
                                               const gchar* text,
                                               const gchar* printer_uri,
                                               const gchar* name,
                                               guint32 state,
                                               const gchar* state_reasons,
                                               gboolean is_accepting_jobs,
                                               guint32 job_id,
                                               guint32 job_state,
                                               const gchar* job_state_reason,
                                               const gchar* job_name,
                                               guint32 job_impressions_completed,
                                               gpointer self);
static void ___lambda6_ (PrintersJob* self,
                  const gchar* text,
                  const gchar* printer_uri,
                  const gchar* name,
                  guint32 state,
                  const gchar* state_reasons,
                  gboolean is_accepting_jobs,
                  guint32 job_id,
                  guint32 job_state,
                  const gchar* job_state_reason,
                  const gchar* job_name,
                  guint32 job_impressions_completed);
static void ____lambda6__cups_notifier_job_stopped (CupsNotifier* _sender,
                                             const gchar* text,
                                             const gchar* printer_uri,
                                             const gchar* name,
                                             guint32 state,
                                             const gchar* state_reasons,
                                             gboolean is_accepting_jobs,
                                             guint32 job_id,
                                             guint32 job_state,
                                             const gchar* job_state_reason,
                                             const gchar* job_name,
                                             guint32 job_impressions_completed,
                                             gpointer self);
static void ___lambda7_ (PrintersJob* self,
                  const gchar* text,
                  const gchar* printer_uri,
                  const gchar* name,
                  guint32 state,
                  const gchar* state_reasons,
                  gboolean is_accepting_jobs,
                  guint32 job_id,
                  guint32 job_state,
                  const gchar* job_state_reason,
                  const gchar* job_name,
                  guint32 job_impressions_completed);
static void ____lambda7__cups_notifier_job_state (CupsNotifier* _sender,
                                           const gchar* text,
                                           const gchar* printer_uri,
                                           const gchar* name,
                                           guint32 state,
                                           const gchar* state_reasons,
                                           gboolean is_accepting_jobs,
                                           guint32 job_id,
                                           guint32 job_state,
                                           const gchar* job_state_reason,
                                           const gchar* job_name,
                                           guint32 job_impressions_completed,
                                           gpointer self);
static void ___lambda8_ (PrintersJob* self,
                  const gchar* text,
                  const gchar* printer_uri,
                  const gchar* name,
                  guint32 state,
                  const gchar* state_reasons,
                  gboolean is_accepting_jobs,
                  guint32 job_id,
                  guint32 job_state,
                  const gchar* job_state_reason,
                  const gchar* job_name,
                  guint32 job_impressions_completed);
static void ____lambda8__cups_notifier_job_state_changed (CupsNotifier* _sender,
                                                   const gchar* text,
                                                   const gchar* printer_uri,
                                                   const gchar* name,
                                                   guint32 state,
                                                   const gchar* state_reasons,
                                                   gboolean is_accepting_jobs,
                                                   guint32 job_id,
                                                   guint32 job_state,
                                                   const gchar* job_state_reason,
                                                   const gchar* job_name,
                                                   guint32 job_impressions_completed,
                                                   gpointer self);
static void printers_job_finalize (GObject * obj);
static GType printers_job_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
printers_job_get_instance_private (PrintersJob* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersJob_private_offset);
}

static void
___lambda5_ (PrintersJob* self,
             const gchar* text,
             const gchar* printer_uri,
             const gchar* name,
             guint32 state,
             const gchar* state_reasons,
             gboolean is_accepting_jobs,
             guint32 job_id,
             guint32 job_state,
             const gchar* job_state_reason,
             const gchar* job_name,
             guint32 job_impressions_completed)
{
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	if (job_id == ((guint32) self->priv->uid)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_COMPLETED_SIGNAL], 0);
	}
}

static void
____lambda5__cups_notifier_job_completed (CupsNotifier* _sender,
                                          const gchar* text,
                                          const gchar* printer_uri,
                                          const gchar* name,
                                          guint32 state,
                                          const gchar* state_reasons,
                                          gboolean is_accepting_jobs,
                                          guint32 job_id,
                                          guint32 job_state,
                                          const gchar* job_state_reason,
                                          const gchar* job_name,
                                          guint32 job_impressions_completed,
                                          gpointer self)
{
	___lambda5_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}

static void
___lambda6_ (PrintersJob* self,
             const gchar* text,
             const gchar* printer_uri,
             const gchar* name,
             guint32 state,
             const gchar* state_reasons,
             gboolean is_accepting_jobs,
             guint32 job_id,
             guint32 job_state,
             const gchar* job_state_reason,
             const gchar* job_name,
             guint32 job_impressions_completed)
{
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	if (job_id == ((guint32) self->priv->uid)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STOPPED_SIGNAL], 0);
	}
}

static void
____lambda6__cups_notifier_job_stopped (CupsNotifier* _sender,
                                        const gchar* text,
                                        const gchar* printer_uri,
                                        const gchar* name,
                                        guint32 state,
                                        const gchar* state_reasons,
                                        gboolean is_accepting_jobs,
                                        guint32 job_id,
                                        guint32 job_state,
                                        const gchar* job_state_reason,
                                        const gchar* job_name,
                                        guint32 job_impressions_completed,
                                        gpointer self)
{
	___lambda6_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}

static void
___lambda7_ (PrintersJob* self,
             const gchar* text,
             const gchar* printer_uri,
             const gchar* name,
             guint32 state,
             const gchar* state_reasons,
             gboolean is_accepting_jobs,
             guint32 job_id,
             guint32 job_state,
             const gchar* job_state_reason,
             const gchar* job_name,
             guint32 job_impressions_completed)
{
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	if (job_id == ((guint32) self->priv->uid)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL], 0);
	}
}

static void
____lambda7__cups_notifier_job_state (CupsNotifier* _sender,
                                      const gchar* text,
                                      const gchar* printer_uri,
                                      const gchar* name,
                                      guint32 state,
                                      const gchar* state_reasons,
                                      gboolean is_accepting_jobs,
                                      guint32 job_id,
                                      guint32 job_state,
                                      const gchar* job_state_reason,
                                      const gchar* job_name,
                                      guint32 job_impressions_completed,
                                      gpointer self)
{
	___lambda7_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}

static void
___lambda8_ (PrintersJob* self,
             const gchar* text,
             const gchar* printer_uri,
             const gchar* name,
             guint32 state,
             const gchar* state_reasons,
             gboolean is_accepting_jobs,
             guint32 job_id,
             guint32 job_state,
             const gchar* job_state_reason,
             const gchar* job_name,
             guint32 job_impressions_completed)
{
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	if (job_id == ((guint32) self->priv->uid)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL], 0);
	}
}

static void
____lambda8__cups_notifier_job_state_changed (CupsNotifier* _sender,
                                              const gchar* text,
                                              const gchar* printer_uri,
                                              const gchar* name,
                                              guint32 state,
                                              const gchar* state_reasons,
                                              gboolean is_accepting_jobs,
                                              guint32 job_id,
                                              guint32 job_state,
                                              const gchar* job_state_reason,
                                              const gchar* job_name,
                                              guint32 job_impressions_completed,
                                              gpointer self)
{
	___lambda8_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}

PrintersJob*
printers_job_construct (GType object_type,
                        cups_job_t* cjob,
                        PrintersPrinter* printer)
{
	PrintersJob * self = NULL;
	cups_job_t _tmp0_;
	cups_job_t _tmp1_;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	cups_job_t _tmp5_;
	g_return_val_if_fail (cjob != NULL, NULL);
	g_return_val_if_fail (printer != NULL, NULL);
	self = (PrintersJob*) g_object_new (object_type, NULL);
	_tmp0_ = *cjob;
	self->cjob = _tmp0_;
	self->priv->printer = printer;
	_tmp1_ = *cjob;
	self->priv->uid = _tmp1_.id;
	_tmp2_ = cups_notifier_get_default ();
	notifier = _tmp2_;
	_tmp5_ = *cjob;
	if (_tmp5_.state != IPP_JOB_CANCELED) {
		cups_job_t _tmp6_;
		_tmp6_ = *cjob;
		_tmp4_ = _tmp6_.state != IPP_JOB_ABORTED;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		cups_job_t _tmp7_;
		_tmp7_ = *cjob;
		_tmp3_ = _tmp7_.state != IPP_JOB_COMPLETED;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		CupsNotifier* _tmp8_;
		CupsNotifier* _tmp9_;
		CupsNotifier* _tmp10_;
		CupsNotifier* _tmp11_;
		_tmp8_ = notifier;
		g_signal_connect_object (_tmp8_, "job-completed", (GCallback) ____lambda5__cups_notifier_job_completed, self, 0);
		_tmp9_ = notifier;
		g_signal_connect_object (_tmp9_, "job-stopped", (GCallback) ____lambda6__cups_notifier_job_stopped, self, 0);
		_tmp10_ = notifier;
		g_signal_connect_object (_tmp10_, "job-state", (GCallback) ____lambda7__cups_notifier_job_state, self, 0);
		_tmp11_ = notifier;
		g_signal_connect_object (_tmp11_, "job-state-changed", (GCallback) ____lambda8__cups_notifier_job_state_changed, self, 0);
	}
	return self;
}

PrintersJob*
printers_job_new (cups_job_t* cjob,
                  PrintersPrinter* printer)
{
	return printers_job_construct (PRINTERS_TYPE_JOB, cjob, printer);
}

void
printers_job_pause (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = cups_pk_helper_job_set_hold_until (_tmp0_, self->priv->uid, "indefinite", &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("Job.vala:68: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
printers_job_stop (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = cups_pk_helper_job_cancel_purge (_tmp0_, self->priv->uid, FALSE, &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("Job.vala:76: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
printers_job_resume (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = cups_pk_helper_job_set_hold_until (_tmp0_, self->priv->uid, "no-hold", &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("Job.vala:84: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

GDateTime*
printers_job_get_used_time (PrintersJob* self)
{
	cups_job_t _tmp0_;
	GDateTime* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	if (_tmp0_.completed_time != ((time_t) 0)) {
		cups_job_t _tmp1_;
		GDateTime* _tmp2_;
		_tmp1_ = self->cjob;
		_tmp2_ = g_date_time_new_from_unix_local ((gint64) _tmp1_.completed_time);
		result = _tmp2_;
		return result;
	} else {
		cups_job_t _tmp3_;
		_tmp3_ = self->cjob;
		if (_tmp3_.processing_time != ((time_t) 0)) {
			cups_job_t _tmp4_;
			GDateTime* _tmp5_;
			_tmp4_ = self->cjob;
			_tmp5_ = g_date_time_new_from_unix_local ((gint64) _tmp4_.processing_time);
			result = _tmp5_;
			return result;
		} else {
			cups_job_t _tmp6_;
			GDateTime* _tmp7_;
			_tmp6_ = self->cjob;
			_tmp7_ = g_date_time_new_from_unix_local ((gint64) _tmp6_.creation_time);
			result = _tmp7_;
			return result;
		}
	}
}

gchar*
printers_job_translated_job_state (PrintersJob* self)
{
	cups_job_t _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	switch (_tmp0_.state) {
		case IPP_JOB_PENDING:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Job Pending"));
			result = _tmp1_;
			return result;
		}
		case IPP_JOB_HELD:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("On Hold"));
			result = _tmp2_;
			return result;
		}
		case IPP_JOB_PROCESSING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Processing…"));
			result = _tmp3_;
			return result;
		}
		case IPP_JOB_STOPPED:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Job Stopped"));
			result = _tmp4_;
			return result;
		}
		case IPP_JOB_CANCELED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Job Canceled"));
			result = _tmp5_;
			return result;
		}
		case IPP_JOB_ABORTED:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Job Aborted"));
			result = _tmp6_;
			return result;
		}
		default:
		case IPP_JOB_COMPLETED:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Job Completed"));
			result = _tmp7_;
			return result;
		}
	}
}

GIcon*
printers_job_state_icon (PrintersJob* self)
{
	cups_job_t _tmp0_;
	GIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	switch (_tmp0_.state) {
		case IPP_JOB_PENDING:
		case IPP_JOB_PROCESSING:
		{
			result = NULL;
			return result;
		}
		case IPP_JOB_HELD:
		case IPP_JOB_STOPPED:
		{
			GThemedIcon* _tmp1_;
			_tmp1_ = (GThemedIcon*) g_themed_icon_new ("media-playback-pause");
			result = (GIcon*) _tmp1_;
			return result;
		}
		case IPP_JOB_CANCELED:
		case IPP_JOB_ABORTED:
		{
			GThemedIcon* _tmp2_;
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
			result = (GIcon*) _tmp2_;
			return result;
		}
		default:
		case IPP_JOB_COMPLETED:
		{
			GThemedIcon* _tmp3_;
			_tmp3_ = (GThemedIcon*) g_themed_icon_new ("process-completed-symbolic");
			result = (GIcon*) _tmp3_;
			return result;
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

GIcon*
printers_job_get_file_icon (PrintersJob* self)
{
	gchar* title = NULL;
	cups_job_t _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	cups_job_t _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GThemedIcon* _tmp21_;
	GIcon* _tmp22_;
	GIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	_tmp1_ = _tmp0_.title;
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
	title = _tmp2_;
	_tmp6_ = title;
	if (string_contains (_tmp6_, ".png")) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = title;
		_tmp5_ = string_contains (_tmp7_, ".jpg");
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp8_;
		_tmp8_ = title;
		_tmp4_ = string_contains (_tmp8_, ".jpeg");
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp9_;
		_tmp9_ = title;
		_tmp3_ = string_contains (_tmp9_, ".bmp");
	}
	if (_tmp3_) {
		GThemedIcon* _tmp10_;
		_tmp10_ = (GThemedIcon*) g_themed_icon_new ("image-x-generic");
		result = (GIcon*) _tmp10_;
		_g_free0 (title);
		return result;
	} else {
		const gchar* _tmp11_;
		_tmp11_ = title;
		if (string_contains (_tmp11_, ".xcf")) {
			GThemedIcon* _tmp12_;
			_tmp12_ = (GThemedIcon*) g_themed_icon_new ("image-x-xcf");
			result = (GIcon*) _tmp12_;
			_g_free0 (title);
			return result;
		} else {
			const gchar* _tmp13_;
			_tmp13_ = title;
			if (string_contains (_tmp13_, ".svg")) {
				GThemedIcon* _tmp14_;
				_tmp14_ = (GThemedIcon*) g_themed_icon_new ("image-x-svg+xml");
				result = (GIcon*) _tmp14_;
				_g_free0 (title);
				return result;
			} else {
				const gchar* _tmp15_;
				_tmp15_ = title;
				if (string_contains (_tmp15_, ".pdf")) {
					GThemedIcon* _tmp16_;
					_tmp16_ = (GThemedIcon*) g_themed_icon_new ("application-pdf");
					result = (GIcon*) _tmp16_;
					_g_free0 (title);
					return result;
				}
			}
		}
	}
	_tmp17_ = self->cjob;
	_tmp18_ = _tmp17_.format;
	_tmp19_ = string_replace (_tmp18_, "/", "-");
	_tmp20_ = _tmp19_;
	_tmp21_ = (GThemedIcon*) g_themed_icon_new (_tmp20_);
	_tmp22_ = (GIcon*) _tmp21_;
	_g_free0 (_tmp20_);
	result = _tmp22_;
	_g_free0 (title);
	return result;
}

gchar*
printers_job_get_hold_until (PrintersJob* self)
{
	gchar* job_uri = NULL;
	gchar* _tmp0_;
	gint job_uri_length1;
	gint _job_uri_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	ipp_t* request = NULL;
	ipp_t* _tmp2_;
	ipp_t* _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar** attributes = NULL;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gint attributes_length1;
	gint _attributes_size_;
	ipp_t* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	http_t* _tmp9_;
	ipp_t* _tmp10_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar, HTTP_MAX_URI);
	job_uri = _tmp0_;
	job_uri_length1 = HTTP_MAX_URI;
	_job_uri_size_ = job_uri_length1;
	_tmp1_ = job_uri;
	_tmp1__length1 = job_uri_length1;
	httpAssembleURIf (HTTP_URI_CODING_QUERY, _tmp1_, (gint) _tmp1__length1, "ipp", NULL, "localhost", 0, "/jobs/%d", self->priv->uid);
	_tmp2_ = ippNewRequest (IPP_GET_JOB_ATTRIBUTES);
	request = _tmp2_;
	_tmp3_ = request;
	_tmp4_ = job_uri;
	_tmp4__length1 = job_uri_length1;
	ippAddString (_tmp3_, IPP_TAG_OPERATION, IPP_TAG_URI, "job-uri", NULL, (const gchar*) _tmp4_);
	_tmp5_ = g_strdup ("job-hold-until");
	_tmp6_ = g_new0 (gchar*, 1 + 1);
	_tmp6_[0] = _tmp5_;
	attributes = _tmp6_;
	attributes_length1 = 1;
	_attributes_size_ = attributes_length1;
	_tmp7_ = request;
	_tmp8_ = attributes;
	_tmp8__length1 = attributes_length1;
	ippAddStrings (_tmp7_, IPP_TAG_OPERATION, IPP_TAG_KEYWORD, "requested-attributes", (gint) _tmp8__length1, NULL, _tmp8_);
	_tmp9_ = CUPS_HTTP_DEFAULT;
	request = cupsDoRequest (_tmp9_, request, "/");
	_tmp10_ = request;
	if (ippGetStatusCode (_tmp10_) <= IPP_OK_CONFLICT) {
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp11_;
		ipp_attribute_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp11_ = request;
		_tmp12_ = ippFindAttribute (_tmp11_, "job-hold-until", IPP_TAG_ZERO);
		attr = _tmp12_;
		_tmp13_ = attr;
		_tmp14_ = ippGetString (_tmp13_, 0, NULL);
		_tmp15_ = g_strdup (_tmp14_);
		result = _tmp15_;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_ippDelete0 (request);
		job_uri = (g_free (job_uri), NULL);
		return result;
	} else {
		ipp_t* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = request;
		_tmp17_ = ippErrorString (ippGetStatusCode (_tmp16_));
		g_critical ("Job.vala:165: Error: %s", _tmp17_);
		_tmp18_ = g_strdup ("no-hold");
		result = _tmp18_;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_ippDelete0 (request);
		job_uri = (g_free (job_uri), NULL);
		return result;
	}
}

static void
printers_job_class_init (PrintersJobClass * klass,
                         gpointer klass_data)
{
	printers_job_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersJob_private_offset);
	G_OBJECT_CLASS (klass)->finalize = printers_job_finalize;
	printers_job_signals[PRINTERS_JOB_STOPPED_SIGNAL] = g_signal_new ("stopped", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	printers_job_signals[PRINTERS_JOB_COMPLETED_SIGNAL] = g_signal_new ("completed", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
printers_job_instance_init (PrintersJob * self,
                            gpointer klass)
{
	self->priv = printers_job_get_instance_private (self);
}

static void
printers_job_finalize (GObject * obj)
{
	PrintersJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOB, PrintersJob);
	G_OBJECT_CLASS (printers_job_parent_class)->finalize (obj);
}

static GType
printers_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJob), 0, (GInstanceInitFunc) printers_job_instance_init, NULL };
	GType printers_job_type_id;
	printers_job_type_id = g_type_register_static (G_TYPE_OBJECT, "PrintersJob", &g_define_type_info, 0);
	PrintersJob_private_offset = g_type_add_instance_private (printers_job_type_id, sizeof (PrintersJobPrivate));
	return printers_job_type_id;
}

GType
printers_job_get_type (void)
{
	static volatile gsize printers_job_type_id__once = 0;
	if (g_once_init_enter (&printers_job_type_id__once)) {
		GType printers_job_type_id;
		printers_job_type_id = printers_job_get_type_once ();
		g_once_init_leave (&printers_job_type_id__once, printers_job_type_id);
	}
	return printers_job_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

