/* InkLevel.c generated by valac 0.55.3, the Vala compiler
 * generated from InkLevel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define PRINTERS_INK_LEVEL_STYLE_CLASS "@define-color levelbar_color %s;\n" \
"    .coloredlevelbar block.filled {\n" \
"        background-image:\n" \
"            linear-gradient(\n" \
"                to bottom,\n" \
"                shade (@levelbar_color, 1.3),\n" \
"                shade (@levelbar_color, 1)\n" \
"            );\n" \
"            border: 1px solid shade (@levelbar_color, 0.85);\n" \
"        box-shadow:\n" \
"            inset 0 0 0 1px alpha (#fff, 0.05),\n" \
"            inset 0 1px 0 0 alpha (#fff, 0.45),\n" \
"            inset 0 -1px 0 0 alpha (#fff, 0.15);\n" \
"    }\n" \
"    "

enum  {
	PRINTERS_INK_LEVEL_0_PROPERTY,
	PRINTERS_INK_LEVEL_PRINTER_PROPERTY,
	PRINTERS_INK_LEVEL_NUM_PROPERTIES
};
static GParamSpec* printers_ink_level_properties[PRINTERS_INK_LEVEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _printers_printer_color_level_unref0(var) ((var == NULL) ? NULL : (var = (printers_printer_color_level_unref (var), NULL)))

struct _PrintersInkLevelPrivate {
	PrintersPrinter* _printer;
};

static gint PrintersInkLevel_private_offset;
static gpointer printers_ink_level_parent_class = NULL;

static const gchar* printers_ink_level_get_translated_name (PrintersInkLevel* self,
                                                     const gchar* name);
static GObject * printers_ink_level_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void printers_ink_level_finalize (GObject * obj);
static GType printers_ink_level_get_type_once (void);
static void _vala_printers_ink_level_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_printers_ink_level_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
printers_ink_level_get_instance_private (PrintersInkLevel* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersInkLevel_private_offset);
}

PrintersInkLevel*
printers_ink_level_construct (GType object_type,
                              PrintersPrinter* printer)
{
	PrintersInkLevel * self = NULL;
	g_return_val_if_fail (printer != NULL, NULL);
	self = (PrintersInkLevel*) g_object_new (object_type, "printer", printer, NULL);
	return self;
}

PrintersInkLevel*
printers_ink_level_new (PrintersPrinter* printer)
{
	return printers_ink_level_construct (PRINTERS_TYPE_INK_LEVEL, printer);
}

static const gchar*
printers_ink_level_get_translated_name (PrintersInkLevel* self,
                                        const gchar* name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	static GQuark _tmp1_label6 = 0;
	static GQuark _tmp1_label7 = 0;
	static GQuark _tmp1_label8 = 0;
	static GQuark _tmp1_label9 = 0;
	static GQuark _tmp1_label10 = 0;
	static GQuark _tmp1_label11 = 0;
	static GQuark _tmp1_label12 = 0;
	static GQuark _tmp1_label13 = 0;
	static GQuark _tmp1_label14 = 0;
	static GQuark _tmp1_label15 = 0;
	static GQuark _tmp1_label16 = 0;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if ((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("black(PGBK)")))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Black(PGBK)"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black (PGBK)");
				return result;
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("black(BK)")))) || (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Black(BK)"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black (BK)");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("black")))) || (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("black ink"))))) || (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("Black"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("yellow")))) || (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("yellow ink"))))) || (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("Yellow"))))) {
		switch (0) {
			default:
			{
				result = _ ("Yellow");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("cyan")))) || (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("cyan ink"))))) || (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("Cyan"))))) {
		switch (0) {
			default:
			{
				result = _ ("Cyan");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("magenta")))) || (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("magenta ink"))))) || (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("Magenta"))))) {
		switch (0) {
			default:
			{
				result = _ ("Magenta");
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("tri-color ink")))) {
		switch (0) {
			default:
			{
				result = _ ("Tri-color");
				return result;
			}
		}
	}
	result = name;
	return result;
}

PrintersPrinter*
printers_ink_level_get_printer (PrintersInkLevel* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_printer;
	result = _tmp0_;
	return result;
}

static void
printers_ink_level_set_printer (PrintersInkLevel* self,
                                PrintersPrinter* value)
{
	PrintersPrinter* old_value;
	g_return_if_fail (self != NULL);
	old_value = printers_ink_level_get_printer (self);
	if (old_value != value) {
		self->priv->_printer = value;
		g_object_notify_by_pspec ((GObject *) self, printers_ink_level_properties[PRINTERS_INK_LEVEL_PRINTER_PROPERTY]);
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GObject *
printers_ink_level_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PrintersInkLevel * self;
	GeeArrayList* colors = NULL;
	PrintersPrinter* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (printers_ink_level_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 6);
	_tmp0_ = self->priv->_printer;
	_tmp1_ = printers_printer_get_color_levels (_tmp0_);
	colors = _tmp1_;
	_tmp2_ = colors;
	_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		g_object_set ((GtkWidget*) self, "height-request", 100, NULL);
	}
	{
		GeeArrayList* _color_list = NULL;
		GeeArrayList* _tmp5_;
		gint _color_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _color_index = 0;
		_tmp5_ = colors;
		_color_list = _tmp5_;
		_tmp6_ = _color_list;
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
		_tmp8_ = _tmp7_;
		_color_size = _tmp8_;
		_color_index = -1;
		while (TRUE) {
			gint _tmp9_;
			gint _tmp10_;
			PrintersPrinterColorLevel* color = NULL;
			GeeArrayList* _tmp11_;
			gpointer _tmp12_;
			gchar** colors_codes = NULL;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gint colors_codes_length1;
			gint _colors_codes_size_;
			PrintersPrinterColorLevel* _tmp15_;
			const gchar* _tmp16_;
			GtkGrid* ink_grid = NULL;
			GtkGrid* _tmp21_;
			const gchar* _tmp22_ = NULL;
			PrintersPrinterColorLevel* _tmp23_;
			const gchar* _tmp24_;
			GtkGrid* _tmp25_;
			const gchar* _tmp26_;
			GtkGrid* _tmp27_;
			GtkStyleContext* _tmp28_;
			GtkGrid* _tmp63_;
			_color_index = _color_index + 1;
			_tmp9_ = _color_index;
			_tmp10_ = _color_size;
			if (!(_tmp9_ < _tmp10_)) {
				break;
			}
			_tmp11_ = _color_list;
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _color_index);
			color = (PrintersPrinterColorLevel*) _tmp12_;
			_tmp13_ = g_strdup ("3689E6");
			_tmp14_ = g_new0 (gchar*, 2 + 1);
			_tmp14_[0] = NULL;
			_tmp14_[1] = _tmp13_;
			colors_codes = _tmp14_;
			colors_codes_length1 = 2;
			_colors_codes_size_ = colors_codes_length1;
			_tmp15_ = color;
			_tmp16_ = _tmp15_->color;
			if (string_contains (_tmp16_, "#")) {
				PrintersPrinterColorLevel* _tmp17_;
				const gchar* _tmp18_;
				gchar** _tmp19_;
				gchar** _tmp20_;
				_tmp17_ = color;
				_tmp18_ = _tmp17_->color;
				_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "#", 0);
				colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
				colors_codes = _tmp20_;
				colors_codes_length1 = _vala_array_length (_tmp19_);
				_colors_codes_size_ = colors_codes_length1;
			}
			_tmp21_ = (GtkGrid*) gtk_grid_new ();
			g_object_ref_sink (_tmp21_);
			ink_grid = _tmp21_;
			_tmp23_ = color;
			_tmp24_ = _tmp23_->name;
			_tmp22_ = _tmp24_;
			if (_tmp22_ == NULL) {
				_tmp22_ = "black";
			}
			_tmp25_ = ink_grid;
			_tmp26_ = printers_ink_level_get_translated_name (self, _tmp22_);
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, _tmp26_);
			_tmp27_ = ink_grid;
			_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
			gtk_style_context_add_class (_tmp28_, GTK_STYLE_CLASS_LINKED);
			{
				gint i = 0;
				i = 1;
				{
					gboolean _tmp29_ = FALSE;
					_tmp29_ = TRUE;
					while (TRUE) {
						gchar** _tmp31_;
						gint _tmp31__length1;
						gchar* css_color = NULL;
						gchar** _tmp32_;
						gint _tmp32__length1;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						GtkLevelBar* level = NULL;
						PrintersPrinterColorLevel* _tmp38_;
						PrintersPrinterColorLevel* _tmp39_;
						GtkLevelBar* _tmp40_;
						GtkLevelBar* _tmp41_;
						GtkLevelBar* _tmp42_;
						PrintersPrinterColorLevel* _tmp43_;
						GtkLevelBar* _tmp44_;
						GtkLevelBar* _tmp45_;
						GtkStyleContext* context = NULL;
						GtkLevelBar* _tmp46_;
						GtkStyleContext* _tmp47_;
						GtkStyleContext* _tmp48_;
						GtkStyleContext* _tmp49_;
						GtkCssProvider* provider = NULL;
						GtkCssProvider* _tmp50_;
						GtkGrid* _tmp61_;
						GtkLevelBar* _tmp62_;
						if (!_tmp29_) {
							gint _tmp30_;
							_tmp30_ = i;
							i = _tmp30_ + 1;
						}
						_tmp29_ = FALSE;
						_tmp31_ = colors_codes;
						_tmp31__length1 = colors_codes_length1;
						if (!(i < _tmp31__length1)) {
							break;
						}
						_tmp32_ = colors_codes;
						_tmp32__length1 = colors_codes_length1;
						_tmp33_ = _tmp32_[i];
						_tmp34_ = g_strconcat ("#", _tmp33_, NULL);
						_tmp35_ = _tmp34_;
						_tmp36_ = g_strdup_printf (PRINTERS_INK_LEVEL_STYLE_CLASS, _tmp35_);
						_tmp37_ = _tmp36_;
						_g_free0 (_tmp35_);
						css_color = _tmp37_;
						_tmp38_ = color;
						_tmp39_ = color;
						_tmp40_ = (GtkLevelBar*) gtk_level_bar_new_for_interval ((gdouble) _tmp38_->level_min, (gdouble) _tmp39_->level_max);
						g_object_ref_sink (_tmp40_);
						level = _tmp40_;
						_tmp41_ = level;
						gtk_orientable_set_orientation ((GtkOrientable*) _tmp41_, GTK_ORIENTATION_VERTICAL);
						_tmp42_ = level;
						_tmp43_ = color;
						gtk_level_bar_set_value (_tmp42_, (gdouble) _tmp43_->level);
						_tmp44_ = level;
						gtk_level_bar_set_inverted (_tmp44_, TRUE);
						_tmp45_ = level;
						g_object_set ((GtkWidget*) _tmp45_, "expand", TRUE, NULL);
						_tmp46_ = level;
						_tmp47_ = gtk_widget_get_style_context ((GtkWidget*) _tmp46_);
						_tmp48_ = _g_object_ref0 (_tmp47_);
						context = _tmp48_;
						_tmp49_ = context;
						gtk_style_context_add_class (_tmp49_, "coloredlevelbar");
						_tmp50_ = gtk_css_provider_new ();
						provider = _tmp50_;
						{
							GtkCssProvider* _tmp51_;
							const gchar* _tmp52_;
							const gchar* _tmp53_;
							gint _tmp54_;
							gint _tmp55_;
							GtkStyleContext* _tmp56_;
							GtkCssProvider* _tmp57_;
							_tmp51_ = provider;
							_tmp52_ = css_color;
							_tmp53_ = css_color;
							_tmp54_ = strlen (_tmp53_);
							_tmp55_ = _tmp54_;
							gtk_css_provider_load_from_data (_tmp51_, _tmp52_, (gssize) _tmp55_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch0_g_error;
							}
							_tmp56_ = context;
							_tmp57_ = provider;
							gtk_style_context_add_provider (_tmp56_, (GtkStyleProvider*) _tmp57_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							GError* _tmp58_;
							const gchar* _tmp59_;
							const gchar* _tmp60_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp58_ = e;
							_tmp59_ = _tmp58_->message;
							_tmp60_ = css_color;
							g_warning ("InkLevel.vala:80: Could not create CSS Provider: %s\nStylesheet:\n%s", _tmp59_, _tmp60_);
							_g_error_free0 (e);
						}
						__finally0:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_object_unref0 (provider);
							_g_object_unref0 (context);
							_g_object_unref0 (level);
							_g_free0 (css_color);
							_g_object_unref0 (ink_grid);
							colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
							_printers_printer_color_level_unref0 (color);
							_g_object_unref0 (colors);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
						}
						_tmp61_ = ink_grid;
						_tmp62_ = level;
						gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
						_g_object_unref0 (provider);
						_g_object_unref0 (context);
						_g_object_unref0 (level);
						_g_free0 (css_color);
					}
				}
			}
			_tmp63_ = ink_grid;
			gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp63_);
			_g_object_unref0 (ink_grid);
			colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
			_printers_printer_color_level_unref0 (color);
		}
	}
	_g_object_unref0 (colors);
	return obj;
}

static void
printers_ink_level_class_init (PrintersInkLevelClass * klass,
                               gpointer klass_data)
{
	printers_ink_level_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersInkLevel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_ink_level_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_ink_level_set_property;
	G_OBJECT_CLASS (klass)->constructor = printers_ink_level_constructor;
	G_OBJECT_CLASS (klass)->finalize = printers_ink_level_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_INK_LEVEL_PRINTER_PROPERTY, printers_ink_level_properties[PRINTERS_INK_LEVEL_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
printers_ink_level_instance_init (PrintersInkLevel * self,
                                  gpointer klass)
{
	self->priv = printers_ink_level_get_instance_private (self);
}

static void
printers_ink_level_finalize (GObject * obj)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	G_OBJECT_CLASS (printers_ink_level_parent_class)->finalize (obj);
}

static GType
printers_ink_level_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersInkLevelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_ink_level_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersInkLevel), 0, (GInstanceInitFunc) printers_ink_level_instance_init, NULL };
	GType printers_ink_level_type_id;
	printers_ink_level_type_id = g_type_register_static (gtk_grid_get_type (), "PrintersInkLevel", &g_define_type_info, 0);
	PrintersInkLevel_private_offset = g_type_add_instance_private (printers_ink_level_type_id, sizeof (PrintersInkLevelPrivate));
	return printers_ink_level_type_id;
}

GType
printers_ink_level_get_type (void)
{
	static volatile gsize printers_ink_level_type_id__once = 0;
	if (g_once_init_enter (&printers_ink_level_type_id__once)) {
		GType printers_ink_level_type_id;
		printers_ink_level_type_id = printers_ink_level_get_type_once ();
		g_once_init_leave (&printers_ink_level_type_id__once, printers_ink_level_type_id);
	}
	return printers_ink_level_type_id__once;
}

static void
_vala_printers_ink_level_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	switch (property_id) {
		case PRINTERS_INK_LEVEL_PRINTER_PROPERTY:
		g_value_set_object (value, printers_ink_level_get_printer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_printers_ink_level_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	switch (property_id) {
		case PRINTERS_INK_LEVEL_PRINTER_PROPERTY:
		printers_ink_level_set_printer (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

